﻿using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
namespace _297Final
{
    class Spaceship  //spaceship class
    {
        int bombs;
        public int Bombs
        {
            get { return bombs; }
            set { bombs = value; }
        }
        Texture2D tex;
        public Texture2D Tex
        {
            get { return tex; }
            set { tex = value; }
        }
        float speed;
        public float Speed
        {
            get { return speed; }
            set { speed = value; }
        }
        bool isSlingshot;
        public bool IsSlingshot
        {
            get { return isSlingshot; }
            set { isSlingshot = value; }
        }
        Vector2 position;
        public Vector2 Position
        {
            get { return position; }
            set { position = value; }
        }
        Rectangle border;
        public Rectangle Border
        {
            get { return border; }
            set { border = value; }
        }
        float deathTime;
        public float DeathTime
        {
            get { return deathTime; }
            set { deathTime = value; }
        }

    }

    class Bomb       //bomb class
    {
        Vector2 pos;
        public Vector2 Pos
        {
            get { return pos; }
            set { pos = value; }
        }
        Circle border;
        public Circle Border
        {
            get { return border; }
            set { border = value; }
        }
        bool isVisible;
        public bool IsVisible
        {
            get{return isVisible;}
            set{isVisible = value;}
        }
        float speed;
        public float Speed
        {
            get { return speed; }
            set { speed = value; }
        }
    }

    class FadeSprite //sprite that can fade in/out
    {
        bool isVisible;
        public bool IsVisible
        {
            get { return isVisible; }
            set { isVisible = value; }
        }
        int alpha;
        public int Alpha
        {
            get { return alpha; }
            set { alpha = value; }
        }
        int increment;  //amount to increment the fade percentage
        public int Increment
        {
            get { return increment; }
            set { increment = value; }
        }
        float delay;   //time to wait before applying next fade in/fade out stage
        public float Delay
        {
            get { return delay; }
            set { delay = value; }
        }
        Texture2D tex;
        public Texture2D Texture
        {
            get { return tex; }
            set { tex = value; }
        }
        public Rectangle Position;
    }

    class Planet    //classes to hold planets characteristics
    {
        float rotateSpd;
        public float RotateSpd
        {
            get { return rotateSpd; }
            set { rotateSpd = value; }
        }

        float angle;
        public float Angle
        {
            get { return angle; }
            set { angle = value; }
        }

        Texture2D texture;
        public Texture2D Tex
        {
            get { return texture; }
            set { texture = value; }
        }
        Vector2 speed;
        public Vector2 Speed
        {
            get { return speed; }
            set { speed = value; }
        }
        
        float size;
        public float Size
        {
            get { return size; }
            set { size = value; }
        }
        Vector2 pos;
        public Vector2 Pos
        {
            get { return pos; }
            set { pos = value; }
        }

        static float time;  //time since last planet spawned
        public static float Time
        {
            get { return time; }
            set { time = value; }
        }

        Circle pCircle;     //bounding circle
        public Circle PCircle
        {
            get { return pCircle; }
            set { pCircle = value; }
        }
    }
    
    enum  GameState  //different game states
    {
        Title,
        Menu,
        Instructions,
        Game,
        EndGame,
        HighScores
    };

    enum PlayerState  //different player states
    {
        Alive,
        Dead,
        Spawning,
        Shield
    };

    class GameFunc  //holds game functions
    {
        //spawn new planets with random position, texture, size, mass
        public static Planet SpawnPlanet(Texture2D[] planets, float distance)
        {
            float d = distance / 400;
            Planet newPlan = new Planet();
            Vector2 position = new Vector2();
            Random Rand = new Random();
            position.X = 2000;                              //spawn off screen
            position.Y = Rand.Next(0, 980);                 //random y value
            newPlan.Angle = 0;                              //angle = 0;
            newPlan.Pos = position;
            newPlan.Tex = planets[Rand.Next(0, 4)];         //pick a random planet tex
            int randomY = Rand.Next(-1, 1);                 //randomize Y velocity for pos/neg
            if (randomY == 0) randomY = Rand.Next(-1, 1);
            newPlan.Speed = new Vector2(Rand.Next(10 + (int)d, 30 + (int)d),        //pick a random x speed
                                        randomY*Rand.Next(1 + (int)d,10 + (int)d)); //pick a random y speed
            newPlan.Size = 0.02f*Rand.Next(5, 20);          //pick a random size
            newPlan.RotateSpd = 0.0005f*Rand.Next(-20, 20); //pick a random rotation speed

            return newPlan;
        }
        public static Bomb SpawnBomb(Texture2D tex,float speed)
        {
            Bomb newbomb = new Bomb();
            newbomb.IsVisible = true;
            Random Rand = new Random();
            newbomb.Pos = new Vector2(2000, Rand.Next(100, 800));
            newbomb.Border = new Circle(newbomb.Pos,tex.Width);
            newbomb.Speed = speed;
            return newbomb;
        }
    }
}